@echo off
cls
if "%1" == "?" goto explain
if not "%1" == "" goto tests
echo This file creates master Distributor's disks for the TCN program on 
echo 360K 5 1/4", or on 720K 3 1/2" floppy disks.
echo.
echo Once
echo.
echo Most distributors will use this file ONCE - and ONLY once - to make a 
echo 360 K distributor's disk set from the 720 K distributor's disk provdided
echo by TCNbP Company.  
echo.
echo A few distributors will receive a 360 Distributor's Disk set (2 disks).
echo These folks may want to make a 720 K Distributor's Disk.  DIST.BAT (this 
echo BATch file) will make that transfer as well.
echo.
echo Again, most distributors will use this file only once.  Therefore, 
echo getting the right files in the right places took precedent over 
echo performance considerations.
echo.
echo This file is not a speed demon.  It just gets the job done.
echo.
pause
cls
echo FILE LISTS
echo.
echo A 720 K distributor's disk contains all the files in a 360 K Distributor's
echo disk set.  The files are identical in the two sets except for one file
echo which is renamed.  USER.DOC in the root directory of the 720 K Distributor's
echo disk is identical (except for its file name) to README.DOC in the root
echo directory of disk 2 of 2 in the 360 K Distributor's disk set.
echo.
echo As is mentioned elsewhere, disk 2 of 2 in a 360 K distributor's disk set
echo is a USER DISK.  When you make a 360 K distributor's disk set from a 720 K
echo Distributor's Disk, all files that do not belong on a USER DISK get copied
echo to disk 1 of 2 into the same directory with the same file name.
echo.
echo When a 720 K distributor's Disk is made from a 360 K Distributor's Disk
echo set, all files from disk 1 of 2 are transfered to the scratch directory,
echo a pause occurs while disk 2 of 2 is mounted, README.DOC on disk 2 of 2
echo is renamed USER.DOC and copied to the scratch directory under that name.
echo Then USER.DOC on disk 2 of 2 is renamed README.DOC.  A pause occurs while
echo the target is mounted.  Then USER.DOC is copied to the root directory of the
echo target under the name USER.DOC.
echo.
pause
cls
echo After you have make a Distributor's Disk master on the other size floppy 
echo using this batch file, you can make backups and customer copies using
echo DOS DISKCOPY or your favorite disk duplicating utility.
echo.
pause
cls
echo DIST.BAT checks your input parameters.
echo.
echo Then it creates the scratch directory you specified on the drive you specify.
echo.
echo Be sure this directory does not exist or that it is empty.  When finished
echo your scratch directory is emptied of all files.  DIST.BAT will not 
echo proceed if your scratch directory is not empty.
echo.
echo Also, use a drive with at least 720K of free space.
echo.
pause
cls
echo Once DIST.BAT has found a sufficient number of valid options, it copies
echo a special utility batch file to the scratch directory.  Then DIST.BAT
echo starts execution of the special utility batch file using the options
echo you gave it.
echo.
echo This step is necessary because of the 2 - disk requirement for 360 K
echo copies.  When making a 720 K Distributor's Disk from a 360 K set, you
echo have to swap source disks.  There is not enough room for a copy of the 
echo batch file on the second disk in the 5 1/4" Distributor's Disk set.
echo From a separate hard drive, the special batch file can copy all required
echo files from the first 360 K disk, pause while source disks are swapped 
echo and continue the file upload to the hard drive.
echo.
echo NOTE:  The 2nd disk in a 360 K distributor's disk set is actually a 
echo        USER DISK.
echo.
echo NOTE:  The special utility BATch file echos all DOS command to the screen
echo so you can see what is happening.  Echo is turned off in this file to
echo produce more readable screens.
echo.
pause
cls
echo Once the special utility has copied all required files to the scratch
echo directory, it pauses to allow you to mount the target floppy.
echo.
echo It then checks to be sure the target floppy is blank.  If not, you are
echo allowed another chance to mount a blank target.  Mastering will not 
echo proceed until a blank target is detected.
echo.
echo NOTE:  The check for a blank target is designed to be adequate to ensure
echo        that you cannot erase an unmodified distributor's disk.  It IS
echo        DEFINITELY POSSIBLE to erase a non-empty disk.  Manually check your
echo        target before running DIST.BAT.
echo.
echo It formats the target disk and, if you specify the optional volume name
echo parameter, names it.
echo.
pause
cls
echo WARNING:  If you specify the letter of a hard drive, it may or may not
echo get formatted.  Watch the screen and don't monkey around with this.
echo If that warning appears, re-boot your computer if that is the only way
echo you know for sure to avoid proceeding.  Don't come crying to TCNbP Company
echo if you erase your hard drive!  You shoulda had it backed up, Bubba!
echo.
echo NOTE:  If the format does not indicate a flawless disk, respond Y to the
echo format another disk prompt.  Blank target test is NOT performed on 2nd disk.
echo.
echo NOTE:  Flawless format is desirable for more efficient operation of
echo typical disk duplication utilities.
echo.
echo NOTE:  If you do not specify a volume name option for DIST.BAT, the DOS
echo format command may prompt you for one.  Or you can use the DOS LABEL 
echo command to give an appropriate volume name later.  Many distributors
echo seem to use volume names to help track disks, so this is important.
echo.
pause
cls
echo After formatting the target, it transfers the appropriate files from the
echo scratch directory to the master Distributor's Disk(s)
echo.
echo This process creates a master Distributor Disk(s) which result(s) in
echo maximum efficiency copying using typical disk duplication software.
echo.
echo Also, the batch file uses the XCOPY command with the /v option.  This
echo has the unfortunate effect of slowing production of the master copy;
echo however, the benefit of verification is worth the time.  After all, this
echo is your MASTER copy of Distributor's Disk(s) being generated here.  
echo Use DOS DISKCOPY or your disk duplication utility to mass produce copies.
echo.
pause
goto explain1
:explain
cls
echo The following information tells what options are required by DIST.BAT
echo and how they are used.
echo.
echo For a more thorough description of the entire process, type DIST with
echo no options.
echo.
echo If you are already familiar with that information, press any key.
echo.
echo If not, use CTRL+C to exit DIST.BAT now and review the more complete
echo information.
echo.
pause
:explain1
cls
echo The parameters used by the DIST.BAT file are as follow:
echo.
echo   1.  Target media capacity (360 or 720)
echo.
echo   2.  Drive specifier for source (A: B: etc.  Include colon.)
echo.
echo   3.  Drive specifier for target (A: B: etc.  Include colon.)
echo.
echo   4.  Scratch directory (must be empty or DIST.BAT will exit without 
echo       making master.  Should be on hard drive or RAM drive with 720K free)
echo.
echo NOTE:  Parameters 1 - 4 are REQUIRED.  Parameters 5 and 6 are optional.
echo.
echo   5.  Volume name for target disk 1 (whatever you want use as the volume 
echo       label)
echo.
echo   6.  Volume name for target disk 2 (360 K only.)
echo.
echo   EXAMPLES:     DIST 360 B: A: C:\SCRATCH
echo.
echo                 DIST 360 B: A: D:\SCRATCH DISK1 DISK2
echo.
echo                 DIST 720 A: B: C:\SCRATCH DISK1
echo.
if "%1" == "?" goto end
pause
cls
echo Use DIST ? in the future for a 2-screen summary of this file.
echo.
goto end
:tests
echo on
if "%1" == "360" goto test2
if "%1" == "720" goto test2
@echo off
cls
echo You typed %1 for the target media capacity.
echo.
echo 360 or 720 are the only values allowed.
goto failed
:test2
if not "%2" == "" goto test2a
goto failed1
:test2a
if exist %2\readme.doc goto test3
@echo off
cls
echo You typed %2 as the source drive specifier.
echo.
echo Either this is wrong or your Distributor's Disk has been altered.
goto failed
:test3
if not "%3" == "" goto test3a
goto failed1
:test3a
If "%3" == "a:" goto test4
If "%3" == "A:" goto test4
If "%3" == "b:" goto test4
If "%3" == "B:" goto test4
@echo off
cls
echo WARNING!
echo.
echo You typed the following command:
echo.
echo    DIST %1 %2 %3 %4 %5 %6
echo.
echo.
echo You did not specify A: or B: as the target drive.
echo.
echo If you included a colon with option 3 (you should have), this means you
echo may be about to format a hard drive.
echo.
echo If %3 specifies a hard drive on this computer, exit this batch file
echo at once!!!  Press CTRL+C and type a Y to exit.  Or, REBOOT your computer
echo if you are not sure.
echo.
pause
:test4
if not "%4" == "" goto test4a
goto failed1
:test4a
if not exist %4\*.* goto test4b
@echo off
cls
echo The scratch directory you specified (%4) is not empty.
echo.
goto failed
:test4b
mkdir %4
xcopy %2\distutil\specutil.bat %4 /v
if exist %4\specutil.bat goto test5
@echo off
cls
echo Could not copy file to scratch directory (%4).
echo.
echo Verify that drive exists and path is valid.
goto failed
:test5
if not "%5" == "" goto test6
@echo off
cls
echo You did not specify a volume name.
goto tellem
pause
goto doit
:test6
if "%1" == "720" goto doit
if not "%6" == "" goto doit
@echo off
cls
echo You did not specify a volume name for disk 2.
:tellem
echo.
echo That is ok.  You can specify a volume name when the DOS FORMAT command
echo prompts you for it.  OR, you can use the DOS LABEL command later.
echo.
pause
:doit
%4\specutil d %1 %2 %3 %4 %5 %6
goto end
:failed1
@echo off
cls
echo Four options are required.  You typed fewer than four options.
:failed
@echo off
echo.
echo You typed the following command:
echo.
echo    DIST %1 %2 %3 %4 %5 %6
echo.
echo Try again with different options.
echo.
echo OR, type DIST with no options or ? for info.
echo.
goto end
:end
