@echo off
cls
if "%1" == "?" goto explain
if not "%1" == "" goto tests
echo This file creates master user disks for the TCN program on 360K 5 1/4"
echo floppy disks or on 720K 3 1/2" "not-so-floppy" disks.
echo.
echo Twice
echo.
echo Most distributors will use this file twice - once to make a 360 K user
echo disk and once to make a 720 K user disk.  Therefore, getting the right
echo files in the right places took precedent over performance considerations.
echo.
echo This file is not a speed demon.  It just gets the job done.
echo.
pause
cls
echo FILELIST
echo.
echo Exactly three files go on either size USER DISK master.  The files are the
echo same for both sizes.
echo.
echo For the purposes of manually checking the results of this batch file, OR
echo for the benefit of those with misgivings about using this batch file, 
echo the list of files on a USER DISK is given below:
echo.
echo    README.DOC
echo    INSTALL.BAT
echo    TCNSTALL.EXE
echo.
echo.
echo  NOTE:  README.DOC on a USER DISK is the file USER.DOC contained in the
echo         root directory of the 720 Distributor's Disk typically shipped
echo         by TCNbP Company.  When USER.BAT is run, USER.DOC is copied to
echo         a scratch directory on your hard drive, renamed README.DOC and
echo         then is copied to the target as README.DOC.
echo.
pause
cls
echo You can make a user disk manually using the preceding file list, OR
echo you can use USER.BAT and verify the results using the preceding list.
echo.
echo Once you have made a USER DISK master on each size floppy, you can make
echo backups and customer copies using DOS DISKCOPY or your favorite disk 
echo duplicating utility.
echo.
pause
cls
echo USER.BAT checks your input parameters.
echo.
echo Then it creates the scratch directory you specified on the drive you specify.
echo.
echo Be sure this directory does not exist or that it is empty.  When finished
echo your scratch directory is emptied of all files.  USER.BAT will not 
echo proceed if your scratch directory is not empty.
echo.
echo Also, use a drive with at least 720K of free space.
echo.
pause
cls
echo Once USER.BAT has found a sufficient number of valid options, it copies
echo a special utility batch file to the scratch directory.  Then USER.BAT
echo starts execution of the special utility batch file using the options
echo you gave it.
echo.
echo This step is necessary because many (if not most) PCs only have one
echo 3 1/2" drive.  Hence, you can't achieve an efficient bulk copy master
echo any other way.
echo.
echo Also, when making 3 1/2" user disks from 5 1/4" distributor disks (it will
echo happen), there is not enough room on the 5 1/4" disk for the batch file and
echo all the required source files.  USER.BAT on disk 1 of 2 copies the utility
echo batch to the scratch directory and calls it.  That batch prompts for a disk
echo swap and begins copying the appropriate files to the scratch directory from
echo 5 1/4" disk 2 of 2.
echo.
echo NOTE:  The special utility BATch file echos all DOS command to the screen
echo so you can see what is happening.  Echo is turned off in this file to
echo produce more readable screens.
echo.
pause
cls
echo Once the special utility has copied all required files to the scratch
echo directory, it pauses to allow you to mount the target floppy.
echo.
echo It then checks to be sure the target floppy is blank.  If not, you are
echo allowed another chance to mount a blank target.  Mastering will not 
echo proceed until a blank target is detected.
echo.
echo NOTE:  The check for a blank target is designed to be adequate to ensure
echo        that you cannot erase an unmodified distributor's disk.  It IS
echo        DEFINITELY POSSIBLE to erase a non-empty disk.  Manually check your
echo        target before running USER.BAT.
echo.
echo It formats the target disk and, if you specify the optional volume name
echo parameter, names it.
echo.
pause
cls
echo WARNING:  If you specify the letter of a hard drive, it may or may not
echo get formatted.  Watch the screen and don't monkey around with this.
echo If that warning appears, re-boot your computer if that is the only way
echo you know for sure to avoid proceeding.  Don't come crying to TCNbP Company
echo if you erase your hard drive!  You shoulda had it backed up, Bubba!
echo.
echo NOTE:  If the format does not indicate a flawless disk, respond Y to the
echo format another disk prompt.  Blank target test is NOT performed on 2nd disk.
echo.
echo NOTE:  Flawless format is desirable for more efficient operation of
echo typical disk duplication utilities.
echo.
echo NOTE:  If you do not specify a volume name option for USER.BAT, the DOS
echo format command may prompt you for one.  Or you can use the DOS LABEL 
echo command to give an appropriate volume name later.  Many distributors
echo seem to use volume names to help track disks, so this is important.
echo.
pause
cls
echo After formatting the target, it transfers the appropriate files from the
echo Distributor's Disk to the master user disk.
echo.
echo This process creates a master USER DISK which results in maximum efficiency
echo copying using typical disk duplication software.
echo.
echo Also, the batch file uses the XCOPY command with the /v option.  This
echo has the unfortunate effect of slowing production of the master copy;
echo however, the benefit of verification is worth the time.  After all, this
echo is your MASTER USER DISK being generated here.  Use DOS DISKCOPY or your
echo disk duplication utility to mass produce copies.
echo.
pause
goto explain1
:explain
cls
echo The following information tells what options are required by USER.BAT
echo and how they are used.
echo.
echo For a more thorough description of the entire process, type USER with
echo no options.
echo.
echo If you are already familiar with that information, press any key.
echo.
echo If not, use CTRL+C to exit USER.BAT now and review the more complete
echo information.
echo.
pause
:explain1
cls
echo The parameters used by the USER.BAT file are as follow:
echo.
echo   1.  Target media capacity (360 or 720)
echo.
echo   2.  Drive specifier for source (A: B: etc.  Include colon.)
echo.
echo   3.  Drive specifier for target (A: B: etc.  Include colon.)
echo.
echo   4.  Scratch directory (must be empty or USER.BAT will exit without 
echo       making master.  Should be on hard drive or RAM drive with 720K free)
echo.
echo NOTE:  Parameters 1 - 4 are REQUIRED.  Parameter 5 is optional.
echo.
echo   5.  Volume name for target (whatever you want use as the volume label)
echo.
echo   EXAMPLES:     USER 360 B: A: C:\SCRATCH
echo.
echo                 USER 360 B: A: D:\SCRATCH DISK1 
echo.
echo                 USER 720 B: B: C:\SCRATCH 
echo.
echo                 USER 720 B: B: C:\SCRATCH DISK1
echo.
if "%1" == "?" goto end
pause
cls
echo Use USER ? in the future for a 2-screen summary of this file.
echo.
goto end
:tests
echo on
if "%1" == "360" goto test2
if "%1" == "720" goto test2
@echo off
cls
echo You typed %1 for the target media capacity.
echo.
echo 360 or 720 are the only values allowed.
goto failed
:test2
if not "%2" == "" goto test2a
goto failed1
:test2a
if exist %2\readme.doc goto test3
@echo off
cls
echo You typed %2 as the source drive specifier.
echo.
echo Either this is wrong or your Distributor's Disk has been altered.
goto failed
:test3
if not "%3" == "" goto test3a
goto failed1
:test3a
If "%3" == "a:" goto test4
If "%3" == "A:" goto test4
If "%3" == "b:" goto test4
If "%3" == "B:" goto test4
@echo off
cls
echo WARNING!
echo.
echo You typed the following command:
echo.
echo    USER %1 %2 %3 %4 %5
echo.
echo.
echo You did not specify A: or B: as the target drive.
echo.
echo If you included a colon with option 3 (you should have), this means you
echo may be about to format a hard drive.
echo.
echo If %3 specifies a hard drive on this computer, exit this batch file
echo at once!!!  Press CTRL+C and type a Y to exit.  Or, REBOOT your computer
echo if you are not sure.
echo.
pause
:test4
if not "%4" == "" goto test4a
goto failed1
:test4a
if not exist %4\*.* goto test4b
@echo off
cls
echo The scratch directory you specified (%4) is not empty.
echo.
goto failed
:test4b
mkdir %4
xcopy %2\distutil\specutil.bat %4 /v
if exist %4\specutil.bat goto test5
@echo off
cls
echo Could not copy file to scratch directory (%4).
echo.
echo Verify that drive exists and path is valid.
goto failed
:test5
if not "%5" == "" goto doit
@echo off
cls
echo You did not specify a volume name.
echo.
echo That is ok.  You can specify a volume name when the DOS FORMAT command
echo prompts you for it.  OR, you can use the DOS LABEL command later.
echo.
pause
:doit
%4\specutil u %1 %2 %3 %4 %5
goto end
:failed1
@echo off
cls
echo Four options are required.  You typed fewer than four options.
:failed
@echo off
cls
echo.
echo You typed the following command:
echo.
echo    USER %1 %2 %3 %4 %5
echo.
echo Try again with different options.
echo.
echo OR, type USER with no options or ? for info.
echo.
goto end
:end
